/* $ANTLR 2.7.5 (20050201): "parser.g" -> "SourceParser.cpp"$ */
#include "SourceParser.hpp"
#include <antlr/NoViableAltException.hpp>
#include <antlr/SemanticException.hpp>
#include <antlr/ASTFactory.hpp>
#line 1 "parser.g"
#line 8 "SourceParser.cpp"
SourceParser::SourceParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(tokenBuf,k)
{
}

SourceParser::SourceParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(tokenBuf,2)
{
}

SourceParser::SourceParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(lexer,k)
{
}

SourceParser::SourceParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(lexer,2)
{
}

SourceParser::SourceParser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(state,2)
{
}

void SourceParser::start() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt start_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	RefASTNodeExt tmp22_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	if ( inputState->guessing == 0 ) {
		tmp22_AST = astFactory->create(LT(1));
		astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp22_AST));
	}
	match(PROGRAM);
	RefASTNodeExt tmp23_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	if ( inputState->guessing == 0 ) {
		tmp23_AST = astFactory->create(LT(1));
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp23_AST));
	}
	match(IDENT);
	match(SEMI);
	{ // ( ... )*
	for (;;) {
		bool synPredMatched5 = false;
		if (((LA(1) == IDENT) && (LA(2) == IDENT || LA(2) == LBRACKET || LA(2) == REF))) {
			int _m5 = mark();
			synPredMatched5 = true;
			inputState->guessing++;
			try {
				{
				declaration();
				match(LPAREN);
				{
				switch ( LA(1)) {
				case IDENT:
				{
					paramList();
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(RPAREN);
				match(LCURLY);
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched5 = false;
			}
			rewind(_m5);
			inputState->guessing--;
		}
		if ( synPredMatched5 ) {
			functionDef();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			bool synPredMatched8 = false;
			if (((LA(1) == IDENT) && (LA(2) == IDENT || LA(2) == LBRACKET || LA(2) == REF))) {
				int _m8 = mark();
				synPredMatched8 = true;
				inputState->guessing++;
				try {
					{
					declaration();
					match(LPAREN);
					{
					switch ( LA(1)) {
					case IDENT:
					{
						paramTypeList();
						break;
					}
					case RPAREN:
					{
						break;
					}
					default:
					{
						throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
					}
					}
					}
					match(RPAREN);
					match(SEMI);
					}
				}
				catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
					synPredMatched8 = false;
				}
				rewind(_m8);
				inputState->guessing--;
			}
			if ( synPredMatched8 ) {
				forward();
				if (inputState->guessing==0) {
					astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
				}
			}
			else if ((LA(1) == IDENT) && (LA(2) == IDENT || LA(2) == LBRACKET || LA(2) == REF)) {
				declaration();
				if (inputState->guessing==0) {
					astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
				}
				match(SEMI);
			}
		else {
			goto _loop9;
		}
		}
	}
	_loop9:;
	} // ( ... )*
	block();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	start_AST = RefASTNodeExt(currentAST.root);
	returnAST = start_AST;
}

void SourceParser::declaration() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt declaration_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt type_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)RefToken  id = ANTLR_USE_NAMESPACE(antlr)nullToken;
	RefASTNodeExt id_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	typeSpec();
	if (inputState->guessing==0) {
		type_AST = returnAST;
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	id = LT(1);
	if ( inputState->guessing == 0 ) {
		id_AST = astFactory->create(id);
		astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(id_AST));
	}
	match(IDENT);
	if ( inputState->guessing==0 ) {
		declaration_AST = RefASTNodeExt(currentAST.root);
#line 256 "parser.g"
		declaration_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(3))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(DECL,"DECL")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(declaration_AST))))))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(type_AST))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(IDENT,id->getText())))));
#line 184 "SourceParser.cpp"
		currentAST.root = declaration_AST;
		if ( declaration_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			declaration_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = declaration_AST->getFirstChild();
		else
			currentAST.child = declaration_AST;
		currentAST.advanceChildToEnd();
	}
	declaration_AST = RefASTNodeExt(currentAST.root);
	returnAST = declaration_AST;
}

void SourceParser::paramList() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt paramList_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	declaration();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == COMMA)) {
			match(COMMA);
			declaration();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop30;
		}
		
	}
	_loop30:;
	} // ( ... )*
	if ( inputState->guessing==0 ) {
		paramList_AST = RefASTNodeExt(currentAST.root);
#line 173 "parser.g"
		paramList_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(PARAMS,"PARAMS")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(paramList_AST))));
#line 226 "SourceParser.cpp"
		currentAST.root = paramList_AST;
		if ( paramList_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			paramList_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = paramList_AST->getFirstChild();
		else
			currentAST.child = paramList_AST;
		currentAST.advanceChildToEnd();
	}
	paramList_AST = RefASTNodeExt(currentAST.root);
	returnAST = paramList_AST;
}

void SourceParser::functionDef() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt functionDef_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	declaration();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	match(LPAREN);
	{
	switch ( LA(1)) {
	case IDENT:
	{
		paramList();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		break;
	}
	case RPAREN:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	match(RPAREN);
	block();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	if ( inputState->guessing==0 ) {
		functionDef_AST = RefASTNodeExt(currentAST.root);
#line 164 "parser.g"
		functionDef_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(FUNCTION,"FUNCTION")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(functionDef_AST))));
#line 278 "SourceParser.cpp"
		currentAST.root = functionDef_AST;
		if ( functionDef_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			functionDef_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = functionDef_AST->getFirstChild();
		else
			currentAST.child = functionDef_AST;
		currentAST.advanceChildToEnd();
	}
	functionDef_AST = RefASTNodeExt(currentAST.root);
	returnAST = functionDef_AST;
}

void SourceParser::paramTypeList() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt paramTypeList_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	typeSpec();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == COMMA)) {
			match(COMMA);
			typeSpec();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop15;
		}
		
	}
	_loop15:;
	} // ( ... )*
	if ( inputState->guessing==0 ) {
		paramTypeList_AST = RefASTNodeExt(currentAST.root);
#line 123 "parser.g"
		paramTypeList_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(PARAMS,"PARAMS")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(paramTypeList_AST))));
#line 320 "SourceParser.cpp"
		currentAST.root = paramTypeList_AST;
		if ( paramTypeList_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			paramTypeList_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = paramTypeList_AST->getFirstChild();
		else
			currentAST.child = paramTypeList_AST;
		currentAST.advanceChildToEnd();
	}
	paramTypeList_AST = RefASTNodeExt(currentAST.root);
	returnAST = paramTypeList_AST;
}

void SourceParser::forward() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt forward_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	functionDecl();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	if ( inputState->guessing==0 ) {
		forward_AST = RefASTNodeExt(currentAST.root);
#line 105 "parser.g"
		forward_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(FORWARD,"FORWARD")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(forward_AST))));
#line 346 "SourceParser.cpp"
		currentAST.root = forward_AST;
		if ( forward_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			forward_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = forward_AST->getFirstChild();
		else
			currentAST.child = forward_AST;
		currentAST.advanceChildToEnd();
	}
	forward_AST = RefASTNodeExt(currentAST.root);
	returnAST = forward_AST;
}

void SourceParser::block() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt block_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	match(LCURLY);
	{ // ( ... )*
	for (;;) {
		if ((_tokenSet_0.member(LA(1)))) {
			statement();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop25;
		}
		
	}
	_loop25:;
	} // ( ... )*
	match(RCURLY);
	if ( inputState->guessing==0 ) {
		block_AST = RefASTNodeExt(currentAST.root);
#line 155 "parser.g"
		block_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(BLOCK,"BLOCK")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(block_AST))));
#line 385 "SourceParser.cpp"
		currentAST.root = block_AST;
		if ( block_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			block_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = block_AST->getFirstChild();
		else
			currentAST.child = block_AST;
		currentAST.advanceChildToEnd();
	}
	block_AST = RefASTNodeExt(currentAST.root);
	returnAST = block_AST;
}

void SourceParser::functionDecl() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt functionDecl_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	declaration();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	match(LPAREN);
	{
	switch ( LA(1)) {
	case IDENT:
	{
		paramTypeList();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		break;
	}
	case RPAREN:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	match(RPAREN);
	match(SEMI);
	if ( inputState->guessing==0 ) {
		functionDecl_AST = RefASTNodeExt(currentAST.root);
#line 114 "parser.g"
		functionDecl_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(FUNCTION,"FUNCTION")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(functionDecl_AST))));
#line 434 "SourceParser.cpp"
		currentAST.root = functionDecl_AST;
		if ( functionDecl_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			functionDecl_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = functionDecl_AST->getFirstChild();
		else
			currentAST.child = functionDecl_AST;
		currentAST.advanceChildToEnd();
	}
	functionDecl_AST = RefASTNodeExt(currentAST.root);
	returnAST = functionDecl_AST;
}

void SourceParser::typeSpec() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt typeSpec_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	RefASTNodeExt tmp35_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	if ( inputState->guessing == 0 ) {
		tmp35_AST = astFactory->create(LT(1));
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp35_AST));
	}
	match(IDENT);
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == REF)) {
			RefASTNodeExt tmp36_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
			if ( inputState->guessing == 0 ) {
				tmp36_AST = astFactory->create(LT(1));
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp36_AST));
			}
			match(REF);
		}
		else {
			goto _loop55;
		}
		
	}
	_loop55:;
	} // ( ... )*
	{
	switch ( LA(1)) {
	case LBRACKET:
	{
		arraySpec();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		break;
	}
	case IDENT:
	case RPAREN:
	case COMMA:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	if ( inputState->guessing==0 ) {
		typeSpec_AST = RefASTNodeExt(currentAST.root);
#line 280 "parser.g"
		typeSpec_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(TYPE,"TYPE")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(typeSpec_AST))));
#line 501 "SourceParser.cpp"
		currentAST.root = typeSpec_AST;
		if ( typeSpec_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			typeSpec_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = typeSpec_AST->getFirstChild();
		else
			currentAST.child = typeSpec_AST;
		currentAST.advanceChildToEnd();
	}
	typeSpec_AST = RefASTNodeExt(currentAST.root);
	returnAST = typeSpec_AST;
}

void SourceParser::statement() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt statement_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	switch ( LA(1)) {
	case BREAK:
	{
		RefASTNodeExt tmp37_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
		if ( inputState->guessing == 0 ) {
			tmp37_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp37_AST));
		}
		match(BREAK);
		match(SEMI);
		statement_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case CONTINUE:
	{
		RefASTNodeExt tmp39_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
		if ( inputState->guessing == 0 ) {
			tmp39_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp39_AST));
		}
		match(CONTINUE);
		match(SEMI);
		statement_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case LCURLY:
	{
		block();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		statement_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case LOOP:
	{
		loop();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		statement_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case IF:
	{
		ifElse();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		statement_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case RETURN:
	{
		returnExpression();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		match(SEMI);
		statement_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case TRUE:
	case FALSE:
	case NULLV:
	case IDENT:
	case LPAREN:
	case NUMERIC:
	case REF:
	case INCR:
	case DECR:
	case MINUS:
	case NOT:
	case ADDR:
	case CHAR:
	case STRING:
	{
		simpleStatement();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		match(SEMI);
		statement_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case WRITE:
	case WRITELN:
	{
		{
		switch ( LA(1)) {
		case WRITE:
		{
			RefASTNodeExt tmp43_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
			if ( inputState->guessing == 0 ) {
				tmp43_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp43_AST));
			}
			match(WRITE);
			break;
		}
		case WRITELN:
		{
			RefASTNodeExt tmp44_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
			if ( inputState->guessing == 0 ) {
				tmp44_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp44_AST));
			}
			match(WRITELN);
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case TRUE:
		case FALSE:
		case NULLV:
		case IDENT:
		case LPAREN:
		case NUMERIC:
		case REF:
		case MINUS:
		case NOT:
		case ADDR:
		case CHAR:
		case STRING:
		{
			expression();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
			{ // ( ... )*
			for (;;) {
				if ((LA(1) == COMMA)) {
					match(COMMA);
					expression();
					if (inputState->guessing==0) {
						astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
					}
				}
				else {
					goto _loop20;
				}
				
			}
			_loop20:;
			} // ( ... )*
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEMI);
		statement_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case READ:
	{
		RefASTNodeExt tmp47_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
		if ( inputState->guessing == 0 ) {
			tmp47_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp47_AST));
		}
		match(READ);
		identifier();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		{ // ( ... )*
		for (;;) {
			if ((LA(1) == COMMA)) {
				match(COMMA);
				identifier();
				if (inputState->guessing==0) {
					astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
				}
			}
			else {
				goto _loop22;
			}
			
		}
		_loop22:;
		} // ( ... )*
		match(SEMI);
		statement_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = statement_AST;
}

void SourceParser::loop() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt loop_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt e1_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt e2_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt e3_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt s_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	RefASTNodeExt tmp50_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	if ( inputState->guessing == 0 ) {
		tmp50_AST = astFactory->create(LT(1));
	}
	match(LOOP);
	match(LPAREN);
	loopInitializerList();
	if (inputState->guessing==0) {
		e1_AST = returnAST;
	}
	match(SEMI);
	loopCondition();
	if (inputState->guessing==0) {
		e2_AST = returnAST;
	}
	match(SEMI);
	loopIteration();
	if (inputState->guessing==0) {
		e3_AST = returnAST;
	}
	match(RPAREN);
	{
	switch ( LA(1)) {
	case TRUE:
	case FALSE:
	case NULLV:
	case RETURN:
	case LOOP:
	case IF:
	case CONTINUE:
	case BREAK:
	case WRITE:
	case WRITELN:
	case READ:
	case IDENT:
	case LPAREN:
	case LCURLY:
	case NUMERIC:
	case REF:
	case INCR:
	case DECR:
	case MINUS:
	case NOT:
	case ADDR:
	case CHAR:
	case STRING:
	{
		statement();
		if (inputState->guessing==0) {
			s_AST = returnAST;
		}
		break;
	}
	case SEMI:
	{
		match(SEMI);
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	if ( inputState->guessing==0 ) {
		loop_AST = RefASTNodeExt(currentAST.root);
#line 201 "parser.g"
		
					if (s_AST == 0) s_AST = astFactory->create(EMPTY,"EMPTY");
					loop_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(LOOPHDR,"loop")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(e1_AST))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(e2_AST))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(s_AST))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(e3_AST))));
				
#line 806 "SourceParser.cpp"
		currentAST.root = loop_AST;
		if ( loop_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			loop_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = loop_AST->getFirstChild();
		else
			currentAST.child = loop_AST;
		currentAST.advanceChildToEnd();
	}
	returnAST = loop_AST;
}

void SourceParser::ifElse() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt ifElse_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	RefASTNodeExt tmp56_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	if ( inputState->guessing == 0 ) {
		tmp56_AST = astFactory->create(LT(1));
		astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp56_AST));
	}
	match(IF);
	match(LPAREN);
	expression();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	match(RPAREN);
	statement();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{
	if ((LA(1) == ELSE) && (_tokenSet_0.member(LA(2)))) {
		match(ELSE);
		statement();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
	}
	else if ((_tokenSet_1.member(LA(1))) && (_tokenSet_2.member(LA(2)))) {
	}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	
	}
	ifElse_AST = RefASTNodeExt(currentAST.root);
	returnAST = ifElse_AST;
}

void SourceParser::returnExpression() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt returnExpression_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	RefASTNodeExt tmp60_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	if ( inputState->guessing == 0 ) {
		tmp60_AST = astFactory->create(LT(1));
		astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp60_AST));
	}
	match(RETURN);
	{
	switch ( LA(1)) {
	case TRUE:
	case FALSE:
	case NULLV:
	case IDENT:
	case LPAREN:
	case NUMERIC:
	case REF:
	case MINUS:
	case NOT:
	case ADDR:
	case CHAR:
	case STRING:
	{
		expression();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		break;
	}
	case SEMI:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	returnExpression_AST = RefASTNodeExt(currentAST.root);
	returnAST = returnExpression_AST;
}

void SourceParser::simpleStatement() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt simpleStatement_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	bool synPredMatched59 = false;
	if (((LA(1) == IDENT) && (LA(2) == IDENT || LA(2) == LBRACKET || LA(2) == REF))) {
		int _m59 = mark();
		synPredMatched59 = true;
		inputState->guessing++;
		try {
			{
			typeSpec();
			match(IDENT);
			}
		}
		catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
			synPredMatched59 = false;
		}
		rewind(_m59);
		inputState->guessing--;
	}
	if ( synPredMatched59 ) {
		definition();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		simpleStatement_AST = RefASTNodeExt(currentAST.root);
	}
	else if ((LA(1) == INCR || LA(1) == DECR)) {
		incDec();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		simpleStatement_AST = RefASTNodeExt(currentAST.root);
	}
	else if ((_tokenSet_3.member(LA(1))) && (_tokenSet_4.member(LA(2)))) {
		assign();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		simpleStatement_AST = RefASTNodeExt(currentAST.root);
	}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	
	returnAST = simpleStatement_AST;
}

void SourceParser::expression() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt expression_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	orExpr();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	expression_AST = RefASTNodeExt(currentAST.root);
	returnAST = expression_AST;
}

void SourceParser::identifier() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt identifier_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)RefToken  id = ANTLR_USE_NAMESPACE(antlr)nullToken;
	RefASTNodeExt id_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	id = LT(1);
	if ( inputState->guessing == 0 ) {
		id_AST = astFactory->create(id);
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(id_AST));
	}
	match(IDENT);
	if ( inputState->guessing==0 ) {
		identifier_AST = RefASTNodeExt(currentAST.root);
#line 484 "parser.g"
		identifier_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(IDENT,"IDENT")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(identifier_AST))));
#line 984 "SourceParser.cpp"
		currentAST.root = identifier_AST;
		if ( identifier_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			identifier_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = identifier_AST->getFirstChild();
		else
			currentAST.child = identifier_AST;
		currentAST.advanceChildToEnd();
	}
	identifier_AST = RefASTNodeExt(currentAST.root);
	returnAST = identifier_AST;
}

void SourceParser::loopInitializerList() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt loopInitializerList_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	{
	switch ( LA(1)) {
	case TRUE:
	case FALSE:
	case NULLV:
	case IDENT:
	case LPAREN:
	case NUMERIC:
	case REF:
	case INCR:
	case DECR:
	case MINUS:
	case NOT:
	case ADDR:
	case CHAR:
	case STRING:
	{
		simpleStatement();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		{ // ( ... )*
		for (;;) {
			if ((LA(1) == COMMA)) {
				match(COMMA);
				simpleStatement();
				if (inputState->guessing==0) {
					astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
				}
			}
			else {
				goto _loop38;
			}
			
		}
		_loop38:;
		} // ( ... )*
		break;
	}
	case SEMI:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	if ( inputState->guessing==0 ) {
		loopInitializerList_AST = RefASTNodeExt(currentAST.root);
#line 213 "parser.g"
		loopInitializerList_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(INIT,"INIT")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(loopInitializerList_AST))));
#line 1055 "SourceParser.cpp"
		currentAST.root = loopInitializerList_AST;
		if ( loopInitializerList_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			loopInitializerList_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = loopInitializerList_AST->getFirstChild();
		else
			currentAST.child = loopInitializerList_AST;
		currentAST.advanceChildToEnd();
	}
	loopInitializerList_AST = RefASTNodeExt(currentAST.root);
	returnAST = loopInitializerList_AST;
}

void SourceParser::loopCondition() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt loopCondition_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	{
	switch ( LA(1)) {
	case TRUE:
	case FALSE:
	case NULLV:
	case IDENT:
	case LPAREN:
	case NUMERIC:
	case REF:
	case MINUS:
	case NOT:
	case ADDR:
	case CHAR:
	case STRING:
	{
		expression();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		break;
	}
	case SEMI:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	if ( inputState->guessing==0 ) {
		loopCondition_AST = RefASTNodeExt(currentAST.root);
#line 222 "parser.g"
		loopCondition_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(COND,"COND")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(loopCondition_AST))));
#line 1108 "SourceParser.cpp"
		currentAST.root = loopCondition_AST;
		if ( loopCondition_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			loopCondition_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = loopCondition_AST->getFirstChild();
		else
			currentAST.child = loopCondition_AST;
		currentAST.advanceChildToEnd();
	}
	loopCondition_AST = RefASTNodeExt(currentAST.root);
	returnAST = loopCondition_AST;
}

void SourceParser::loopIteration() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt loopIteration_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	{
	switch ( LA(1)) {
	case TRUE:
	case FALSE:
	case NULLV:
	case IDENT:
	case LPAREN:
	case NUMERIC:
	case REF:
	case INCR:
	case DECR:
	case MINUS:
	case NOT:
	case ADDR:
	case CHAR:
	case STRING:
	{
		simpleStatement();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		{ // ( ... )*
		for (;;) {
			if ((LA(1) == COMMA)) {
				match(COMMA);
				simpleStatement();
				if (inputState->guessing==0) {
					astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
				}
			}
			else {
				goto _loop44;
			}
			
		}
		_loop44:;
		} // ( ... )*
		break;
	}
	case RPAREN:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	if ( inputState->guessing==0 ) {
		loopIteration_AST = RefASTNodeExt(currentAST.root);
#line 231 "parser.g"
		loopIteration_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(ITER,"ITER")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(loopIteration_AST))));
#line 1179 "SourceParser.cpp"
		currentAST.root = loopIteration_AST;
		if ( loopIteration_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			loopIteration_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = loopIteration_AST->getFirstChild();
		else
			currentAST.child = loopIteration_AST;
		currentAST.advanceChildToEnd();
	}
	loopIteration_AST = RefASTNodeExt(currentAST.root);
	returnAST = loopIteration_AST;
}

void SourceParser::definition() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt definition_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	declaration();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{
	switch ( LA(1)) {
	case ASSIGN:
	{
		RefASTNodeExt tmp63_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
		if ( inputState->guessing == 0 ) {
			tmp63_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp63_AST));
		}
		match(ASSIGN);
		expression();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		break;
	}
	case SEMI:
	case RPAREN:
	case COMMA:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	definition_AST = RefASTNodeExt(currentAST.root);
	returnAST = definition_AST;
}

void SourceParser::arraySpec() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt arraySpec_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	{ // ( ... )+
	int _cnt52=0;
	for (;;) {
		if ((LA(1) == LBRACKET)) {
			match(LBRACKET);
			RefASTNodeExt tmp65_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
			if ( inputState->guessing == 0 ) {
				tmp65_AST = astFactory->create(LT(1));
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp65_AST));
			}
			match(NUMERIC);
			match(RBRACKET);
		}
		else {
			if ( _cnt52>=1 ) { goto _loop52; } else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());}
		}
		
		_cnt52++;
	}
	_loop52:;
	}  // ( ... )+
	if ( inputState->guessing==0 ) {
		arraySpec_AST = RefASTNodeExt(currentAST.root);
#line 271 "parser.g"
		arraySpec_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(ARRAY,"ARRAY")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(arraySpec_AST))));
#line 1263 "SourceParser.cpp"
		currentAST.root = arraySpec_AST;
		if ( arraySpec_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			arraySpec_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = arraySpec_AST->getFirstChild();
		else
			currentAST.child = arraySpec_AST;
		currentAST.advanceChildToEnd();
	}
	arraySpec_AST = RefASTNodeExt(currentAST.root);
	returnAST = arraySpec_AST;
}

void SourceParser::incDec() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt incDec_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	switch ( LA(1)) {
	case INCR:
	{
		match(INCR);
		specialUnaryExpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		if ( inputState->guessing==0 ) {
			incDec_AST = RefASTNodeExt(currentAST.root);
#line 302 "parser.g"
			incDec_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(INC,"INC")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(incDec_AST))));
#line 1293 "SourceParser.cpp"
			currentAST.root = incDec_AST;
			if ( incDec_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
				incDec_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				  currentAST.child = incDec_AST->getFirstChild();
			else
				currentAST.child = incDec_AST;
			currentAST.advanceChildToEnd();
		}
		incDec_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case DECR:
	{
		match(DECR);
		specialUnaryExpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		if ( inputState->guessing==0 ) {
			incDec_AST = RefASTNodeExt(currentAST.root);
#line 306 "parser.g"
			incDec_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(DEC,"DEC")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(incDec_AST))));
#line 1316 "SourceParser.cpp"
			currentAST.root = incDec_AST;
			if ( incDec_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
				incDec_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				  currentAST.child = incDec_AST->getFirstChild();
			else
				currentAST.child = incDec_AST;
			currentAST.advanceChildToEnd();
		}
		incDec_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = incDec_AST;
}

void SourceParser::assign() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt assign_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	expression();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{
	switch ( LA(1)) {
	case ASSIGN:
	{
		RefASTNodeExt tmp69_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
		if ( inputState->guessing == 0 ) {
			tmp69_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp69_AST));
		}
		match(ASSIGN);
		expression();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		break;
	}
	case SEMI:
	case RPAREN:
	case COMMA:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	assign_AST = RefASTNodeExt(currentAST.root);
	returnAST = assign_AST;
}

void SourceParser::specialUnaryExpr() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt specialUnaryExpr_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	switch ( LA(1)) {
	case ADDR:
	{
		RefASTNodeExt tmp70_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
		if ( inputState->guessing == 0 ) {
			tmp70_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp70_AST));
		}
		match(ADDR);
		postfixExpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		specialUnaryExpr_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case REF:
	{
		RefASTNodeExt tmp71_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
		if ( inputState->guessing == 0 ) {
			tmp71_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp71_AST));
		}
		match(REF);
		specialUnaryExpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		specialUnaryExpr_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	default:
		bool synPredMatched90 = false;
		if (((LA(1) == LPAREN) && (LA(2) == IDENT))) {
			int _m90 = mark();
			synPredMatched90 = true;
			inputState->guessing++;
			try {
				{
				match(LPAREN);
				typeSpec();
				match(RPAREN);
				specialUnaryExpr();
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched90 = false;
			}
			rewind(_m90);
			inputState->guessing--;
		}
		if ( synPredMatched90 ) {
			match(LPAREN);
			typeSpec();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
			match(RPAREN);
			specialUnaryExpr();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
			if ( inputState->guessing==0 ) {
				specialUnaryExpr_AST = RefASTNodeExt(currentAST.root);
#line 373 "parser.g"
				specialUnaryExpr_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(CAST,"CAST")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(specialUnaryExpr_AST))));
#line 1448 "SourceParser.cpp"
				currentAST.root = specialUnaryExpr_AST;
				if ( specialUnaryExpr_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
					specialUnaryExpr_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
					  currentAST.child = specialUnaryExpr_AST->getFirstChild();
				else
					currentAST.child = specialUnaryExpr_AST;
				currentAST.advanceChildToEnd();
			}
			specialUnaryExpr_AST = RefASTNodeExt(currentAST.root);
		}
		else if ((_tokenSet_5.member(LA(1))) && (_tokenSet_6.member(LA(2)))) {
			postfixExpr();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
			specialUnaryExpr_AST = RefASTNodeExt(currentAST.root);
		}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = specialUnaryExpr_AST;
}

void SourceParser::orExpr() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt orExpr_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	andExpr();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == OR)) {
			RefASTNodeExt tmp74_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
			if ( inputState->guessing == 0 ) {
				tmp74_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp74_AST));
			}
			match(OR);
			andExpr();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop66;
		}
		
	}
	_loop66:;
	} // ( ... )*
	orExpr_AST = RefASTNodeExt(currentAST.root);
	returnAST = orExpr_AST;
}

void SourceParser::andExpr() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt andExpr_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	logPrimary();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == AND)) {
			RefASTNodeExt tmp75_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
			if ( inputState->guessing == 0 ) {
				tmp75_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp75_AST));
			}
			match(AND);
			logPrimary();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop69;
		}
		
	}
	_loop69:;
	} // ( ... )*
	andExpr_AST = RefASTNodeExt(currentAST.root);
	returnAST = andExpr_AST;
}

void SourceParser::logPrimary() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt logPrimary_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	relExpr();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == NEQ || LA(1) == EQ)) {
			{
			switch ( LA(1)) {
			case NEQ:
			{
				RefASTNodeExt tmp76_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp76_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp76_AST));
				}
				match(NEQ);
				break;
			}
			case EQ:
			{
				RefASTNodeExt tmp77_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp77_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp77_AST));
				}
				match(EQ);
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
			relExpr();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop73;
		}
		
	}
	_loop73:;
	} // ( ... )*
	logPrimary_AST = RefASTNodeExt(currentAST.root);
	returnAST = logPrimary_AST;
}

void SourceParser::relExpr() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt relExpr_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	additiveExpr();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{ // ( ... )*
	for (;;) {
		if (((LA(1) >= TK_LT && LA(1) <= GE))) {
			{
			switch ( LA(1)) {
			case TK_LT:
			{
				RefASTNodeExt tmp78_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp78_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp78_AST));
				}
				match(TK_LT);
				break;
			}
			case GT:
			{
				RefASTNodeExt tmp79_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp79_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp79_AST));
				}
				match(GT);
				break;
			}
			case LE:
			{
				RefASTNodeExt tmp80_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp80_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp80_AST));
				}
				match(LE);
				break;
			}
			case GE:
			{
				RefASTNodeExt tmp81_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp81_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp81_AST));
				}
				match(GE);
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
			additiveExpr();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop77;
		}
		
	}
	_loop77:;
	} // ( ... )*
	relExpr_AST = RefASTNodeExt(currentAST.root);
	returnAST = relExpr_AST;
}

void SourceParser::additiveExpr() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt additiveExpr_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	multiplicativeExpr();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == PLUS || LA(1) == MINUS)) {
			{
			switch ( LA(1)) {
			case PLUS:
			{
				RefASTNodeExt tmp82_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp82_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp82_AST));
				}
				match(PLUS);
				break;
			}
			case MINUS:
			{
				RefASTNodeExt tmp83_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp83_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp83_AST));
				}
				match(MINUS);
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
			multiplicativeExpr();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop81;
		}
		
	}
	_loop81:;
	} // ( ... )*
	additiveExpr_AST = RefASTNodeExt(currentAST.root);
	returnAST = additiveExpr_AST;
}

void SourceParser::multiplicativeExpr() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt multiplicativeExpr_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	unaryExpr();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{ // ( ... )*
	for (;;) {
		if (((LA(1) >= STAR && LA(1) <= MODULO))) {
			{
			switch ( LA(1)) {
			case STAR:
			{
				RefASTNodeExt tmp84_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp84_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp84_AST));
				}
				match(STAR);
				break;
			}
			case DIVIDE:
			{
				RefASTNodeExt tmp85_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp85_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp85_AST));
				}
				match(DIVIDE);
				break;
			}
			case MODULO:
			{
				RefASTNodeExt tmp86_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
				if ( inputState->guessing == 0 ) {
					tmp86_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp86_AST));
				}
				match(MODULO);
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
			unaryExpr();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop85;
		}
		
	}
	_loop85:;
	} // ( ... )*
	multiplicativeExpr_AST = RefASTNodeExt(currentAST.root);
	returnAST = multiplicativeExpr_AST;
}

void SourceParser::unaryExpr() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt unaryExpr_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	switch ( LA(1)) {
	case MINUS:
	case NOT:
	{
		{
		switch ( LA(1)) {
		case MINUS:
		{
			RefASTNodeExt tmp87_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
			if ( inputState->guessing == 0 ) {
				tmp87_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp87_AST));
			}
			match(MINUS);
			break;
		}
		case NOT:
		{
			RefASTNodeExt tmp88_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
			if ( inputState->guessing == 0 ) {
				tmp88_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp88_AST));
			}
			match(NOT);
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
		}
		}
		}
		unaryExpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		unaryExpr_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case TRUE:
	case FALSE:
	case NULLV:
	case IDENT:
	case LPAREN:
	case NUMERIC:
	case REF:
	case ADDR:
	case CHAR:
	case STRING:
	{
		specialUnaryExpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		unaryExpr_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = unaryExpr_AST;
}

void SourceParser::postfixExpr() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt postfixExpr_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	primaryExpr();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{
	switch ( LA(1)) {
	case LBRACKET:
	{
		RefASTNodeExt tmp89_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
		if ( inputState->guessing == 0 ) {
			tmp89_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(tmp89_AST));
		}
		match(LBRACKET);
		expression();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		match(RBRACKET);
		{ // ( ... )*
		for (;;) {
			if ((LA(1) == LBRACKET)) {
				match(LBRACKET);
				expression();
				if (inputState->guessing==0) {
					astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
				}
				match(RBRACKET);
			}
			else {
				goto _loop94;
			}
			
		}
		_loop94:;
		} // ( ... )*
		break;
	}
	case SEMI:
	case RPAREN:
	case COMMA:
	case ASSIGN:
	case RBRACKET:
	case OR:
	case AND:
	case NEQ:
	case EQ:
	case TK_LT:
	case GT:
	case LE:
	case GE:
	case PLUS:
	case MINUS:
	case STAR:
	case DIVIDE:
	case MODULO:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	postfixExpr_AST = RefASTNodeExt(currentAST.root);
	returnAST = postfixExpr_AST;
}

void SourceParser::primaryExpr() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt primaryExpr_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	switch ( LA(1)) {
	case LPAREN:
	{
		match(LPAREN);
		expression();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		match(RPAREN);
		primaryExpr_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case TRUE:
	case FALSE:
	case NULLV:
	case NUMERIC:
	case CHAR:
	case STRING:
	{
		constant();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		primaryExpr_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	default:
		bool synPredMatched97 = false;
		if (((LA(1) == IDENT) && (LA(2) == LPAREN))) {
			int _m97 = mark();
			synPredMatched97 = true;
			inputState->guessing++;
			try {
				{
				match(IDENT);
				match(LPAREN);
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched97 = false;
			}
			rewind(_m97);
			inputState->guessing--;
		}
		if ( synPredMatched97 ) {
			call();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
			primaryExpr_AST = RefASTNodeExt(currentAST.root);
		}
		else if ((LA(1) == IDENT) && (_tokenSet_7.member(LA(2)))) {
			identifier();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
			primaryExpr_AST = RefASTNodeExt(currentAST.root);
		}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = primaryExpr_AST;
}

void SourceParser::call() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt call_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)RefToken  id = ANTLR_USE_NAMESPACE(antlr)nullToken;
	RefASTNodeExt id_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	id = LT(1);
	if ( inputState->guessing == 0 ) {
		id_AST = astFactory->create(id);
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(id_AST));
	}
	match(IDENT);
	match(LPAREN);
	{
	switch ( LA(1)) {
	case TRUE:
	case FALSE:
	case NULLV:
	case IDENT:
	case LPAREN:
	case NUMERIC:
	case REF:
	case MINUS:
	case NOT:
	case ADDR:
	case CHAR:
	case STRING:
	{
		args();
		if (inputState->guessing==0) {
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
		}
		break;
	}
	case RPAREN:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
	match(RPAREN);
	if ( inputState->guessing==0 ) {
		call_AST = RefASTNodeExt(currentAST.root);
#line 408 "parser.g"
		call_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(CALL,"CALL")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(call_AST))));
#line 2059 "SourceParser.cpp"
		currentAST.root = call_AST;
		if ( call_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			call_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = call_AST->getFirstChild();
		else
			currentAST.child = call_AST;
		currentAST.advanceChildToEnd();
	}
	call_AST = RefASTNodeExt(currentAST.root);
	returnAST = call_AST;
}

void SourceParser::constant() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt constant_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)RefToken  n = ANTLR_USE_NAMESPACE(antlr)nullToken;
	RefASTNodeExt n_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)RefToken  c = ANTLR_USE_NAMESPACE(antlr)nullToken;
	RefASTNodeExt c_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)RefToken  t = ANTLR_USE_NAMESPACE(antlr)nullToken;
	RefASTNodeExt t_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)RefToken  f = ANTLR_USE_NAMESPACE(antlr)nullToken;
	RefASTNodeExt f_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)RefToken  z = ANTLR_USE_NAMESPACE(antlr)nullToken;
	RefASTNodeExt z_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)RefToken  s = ANTLR_USE_NAMESPACE(antlr)nullToken;
	RefASTNodeExt s_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 422 "parser.g"
	
		string value;
	
#line 2092 "SourceParser.cpp"
	
	switch ( LA(1)) {
	case NUMERIC:
	{
		n = LT(1);
		if ( inputState->guessing == 0 ) {
			n_AST = astFactory->create(n);
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(n_AST));
		}
		match(NUMERIC);
		if ( inputState->guessing==0 ) {
			constant_AST = RefASTNodeExt(currentAST.root);
#line 429 "parser.g"
			
						value = n->getText();
						size_t p = value.find(".");
						
						constant_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(CONST,"CONST")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(constant_AST))))))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(NUMERIC,value)))));
					
#line 2112 "SourceParser.cpp"
			currentAST.root = constant_AST;
			if ( constant_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
				constant_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				  currentAST.child = constant_AST->getFirstChild();
			else
				currentAST.child = constant_AST;
			currentAST.advanceChildToEnd();
		}
		constant_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case CHAR:
	{
		c = LT(1);
		if ( inputState->guessing == 0 ) {
			c_AST = astFactory->create(c);
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(c_AST));
		}
		match(CHAR);
		if ( inputState->guessing==0 ) {
			constant_AST = RefASTNodeExt(currentAST.root);
#line 438 "parser.g"
			
						value = c->getText();
						value = value.substr(1, value.size() - 2);
			
						constant_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(CONST,"CONST")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(constant_AST))))))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(CHAR,value)))));
					
#line 2141 "SourceParser.cpp"
			currentAST.root = constant_AST;
			if ( constant_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
				constant_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				  currentAST.child = constant_AST->getFirstChild();
			else
				currentAST.child = constant_AST;
			currentAST.advanceChildToEnd();
		}
		constant_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case TRUE:
	{
		t = LT(1);
		if ( inputState->guessing == 0 ) {
			t_AST = astFactory->create(t);
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(t_AST));
		}
		match(TRUE);
		if ( inputState->guessing==0 ) {
			constant_AST = RefASTNodeExt(currentAST.root);
#line 447 "parser.g"
			
						value = t->getText();
			
						constant_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(CONST,"CONST")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(constant_AST))))))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(TRUE,value)))));
					
#line 2169 "SourceParser.cpp"
			currentAST.root = constant_AST;
			if ( constant_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
				constant_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				  currentAST.child = constant_AST->getFirstChild();
			else
				currentAST.child = constant_AST;
			currentAST.advanceChildToEnd();
		}
		constant_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case FALSE:
	{
		f = LT(1);
		if ( inputState->guessing == 0 ) {
			f_AST = astFactory->create(f);
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(f_AST));
		}
		match(FALSE);
		if ( inputState->guessing==0 ) {
			constant_AST = RefASTNodeExt(currentAST.root);
#line 455 "parser.g"
			
						value = f->getText();
			
						constant_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(CONST,"CONST")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(constant_AST))))))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(FALSE,value)))));
					
#line 2197 "SourceParser.cpp"
			currentAST.root = constant_AST;
			if ( constant_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
				constant_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				  currentAST.child = constant_AST->getFirstChild();
			else
				currentAST.child = constant_AST;
			currentAST.advanceChildToEnd();
		}
		constant_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case NULLV:
	{
		z = LT(1);
		if ( inputState->guessing == 0 ) {
			z_AST = astFactory->create(z);
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(z_AST));
		}
		match(NULLV);
		if ( inputState->guessing==0 ) {
			constant_AST = RefASTNodeExt(currentAST.root);
#line 463 "parser.g"
			
						value = z->getText();
			
			
						constant_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(CONST,"CONST")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(constant_AST))))))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(NULLV,value)))));
					
#line 2226 "SourceParser.cpp"
			currentAST.root = constant_AST;
			if ( constant_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
				constant_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				  currentAST.child = constant_AST->getFirstChild();
			else
				currentAST.child = constant_AST;
			currentAST.advanceChildToEnd();
		}
		constant_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	case STRING:
	{
		s = LT(1);
		if ( inputState->guessing == 0 ) {
			s_AST = astFactory->create(s);
			astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(s_AST));
		}
		match(STRING);
		if ( inputState->guessing==0 ) {
			constant_AST = RefASTNodeExt(currentAST.root);
#line 472 "parser.g"
			
						value = s->getText();
			
						constant_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(CONST,"CONST")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(constant_AST))))))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(STRING,value)))));
					
#line 2254 "SourceParser.cpp"
			currentAST.root = constant_AST;
			if ( constant_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
				constant_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				  currentAST.child = constant_AST->getFirstChild();
			else
				currentAST.child = constant_AST;
			currentAST.advanceChildToEnd();
		}
		constant_AST = RefASTNodeExt(currentAST.root);
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = constant_AST;
}

void SourceParser::args() {
	returnAST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	RefASTNodeExt args_AST = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	expression();
	if (inputState->guessing==0) {
		astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == COMMA)) {
			match(COMMA);
			expression();
			if (inputState->guessing==0) {
				astFactory->addASTChild(currentAST, ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST));
			}
		}
		else {
			goto _loop102;
		}
		
	}
	_loop102:;
	} // ( ... )*
	if ( inputState->guessing==0 ) {
		args_AST = RefASTNodeExt(currentAST.root);
#line 417 "parser.g"
		args_AST = RefASTNodeExt(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->create(ARGS,"ARGS")))->add(ANTLR_USE_NAMESPACE(antlr)RefAST(args_AST))));
#line 2303 "SourceParser.cpp"
		currentAST.root = args_AST;
		if ( args_AST!=RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) &&
			args_AST->getFirstChild() != RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			  currentAST.child = args_AST->getFirstChild();
		else
			currentAST.child = args_AST;
		currentAST.advanceChildToEnd();
	}
	args_AST = RefASTNodeExt(currentAST.root);
	returnAST = args_AST;
}

void SourceParser::initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory )
{
	factory.setMaxNodeType(77);
}
const char* SourceParser::tokenNames[] = {
	"<0>",
	"EOF",
	"<2>",
	"NULL_TREE_LOOKAHEAD",
	"\"program\"",
	"\"true\"",
	"\"false\"",
	"\"null\"",
	"\"return\"",
	"\"loop\"",
	"\"if\"",
	"\"else\"",
	"\"continue\"",
	"\"break\"",
	"\"write\"",
	"\"writeln\"",
	"\"read\"",
	"DECL",
	"TYPE",
	"ARRAY",
	"SCOPE",
	"BLOCK",
	"CAST",
	"DIM",
	"CONST",
	"CALL",
	"FUNCTION",
	"PARAMS",
	"INIT",
	"COND",
	"ITER",
	"LOOPHDR",
	"ARGS",
	"EMPTY",
	"INC",
	"DEC",
	"IDENT",
	"SEMI",
	"LPAREN",
	"RPAREN",
	"LCURLY",
	"COMMA",
	"RCURLY",
	"ASSIGN",
	"LBRACKET",
	"NUMERIC",
	"RBRACKET",
	"REF",
	"INCR",
	"DECR",
	"OR",
	"AND",
	"NEQ",
	"EQ",
	"TK_LT",
	"GT",
	"LE",
	"GE",
	"PLUS",
	"MINUS",
	"STAR",
	"DIVIDE",
	"MODULO",
	"NOT",
	"ADDR",
	"CHAR",
	"STRING",
	"WS",
	"DOT",
	"ARROW",
	"DIRECTIVE",
	"INS_START",
	"INS_END",
	"COMMENT",
	"COMMENT_2",
	"DIGIT",
	"LETTER",
	"FORWARD",
	0
};

const unsigned long SourceParser::_tokenSet_0_data_[] = { 128992UL, 2281939280UL, 7UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "true" "false" "null" "return" "loop" "if" "continue" "break" "write" 
// "writeln" "read" IDENT LPAREN LCURLY NUMERIC REF INCR DECR MINUS NOT 
// ADDR CHAR STRING 
const ANTLR_USE_NAMESPACE(antlr)BitSet SourceParser::_tokenSet_0(_tokenSet_0_data_,8);
const unsigned long SourceParser::_tokenSet_1_data_[] = { 131040UL, 2281940304UL, 7UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "true" "false" "null" "return" "loop" "if" "else" "continue" "break" 
// "write" "writeln" "read" IDENT LPAREN LCURLY RCURLY NUMERIC REF INCR 
// DECR MINUS NOT ADDR CHAR STRING 
const ANTLR_USE_NAMESPACE(antlr)BitSet SourceParser::_tokenSet_1(_tokenSet_1_data_,8);
const unsigned long SourceParser::_tokenSet_2_data_[] = { 131042UL, 4294950256UL, 7UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// EOF "true" "false" "null" "return" "loop" "if" "else" "continue" "break" 
// "write" "writeln" "read" IDENT SEMI LPAREN LCURLY RCURLY ASSIGN LBRACKET 
// NUMERIC REF INCR DECR OR AND NEQ EQ TK_LT GT LE GE PLUS MINUS STAR DIVIDE 
// MODULO NOT ADDR CHAR STRING 
const ANTLR_USE_NAMESPACE(antlr)BitSet SourceParser::_tokenSet_2(_tokenSet_2_data_,8);
const unsigned long SourceParser::_tokenSet_3_data_[] = { 224UL, 2281742416UL, 7UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "true" "false" "null" IDENT LPAREN NUMERIC REF MINUS NOT ADDR CHAR STRING 
const ANTLR_USE_NAMESPACE(antlr)BitSet SourceParser::_tokenSet_3(_tokenSet_3_data_,8);
const unsigned long SourceParser::_tokenSet_4_data_[] = { 224UL, 4294753008UL, 7UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "true" "false" "null" IDENT SEMI LPAREN RPAREN COMMA ASSIGN LBRACKET 
// NUMERIC REF OR AND NEQ EQ TK_LT GT LE GE PLUS MINUS STAR DIVIDE MODULO 
// NOT ADDR CHAR STRING 
const ANTLR_USE_NAMESPACE(antlr)BitSet SourceParser::_tokenSet_4(_tokenSet_4_data_,8);
const unsigned long SourceParser::_tokenSet_5_data_[] = { 224UL, 8272UL, 6UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "true" "false" "null" IDENT LPAREN NUMERIC CHAR STRING 
const ANTLR_USE_NAMESPACE(antlr)BitSet SourceParser::_tokenSet_5(_tokenSet_5_data_,8);
const unsigned long SourceParser::_tokenSet_6_data_[] = { 224UL, 4294769392UL, 7UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "true" "false" "null" IDENT SEMI LPAREN RPAREN COMMA ASSIGN LBRACKET 
// NUMERIC RBRACKET REF OR AND NEQ EQ TK_LT GT LE GE PLUS MINUS STAR DIVIDE 
// MODULO NOT ADDR CHAR STRING 
const ANTLR_USE_NAMESPACE(antlr)BitSet SourceParser::_tokenSet_6(_tokenSet_6_data_,8);
const unsigned long SourceParser::_tokenSet_7_data_[] = { 0UL, 2147244704UL, 0UL, 0UL };
// SEMI RPAREN COMMA ASSIGN LBRACKET RBRACKET OR AND NEQ EQ TK_LT GT LE 
// GE PLUS MINUS STAR DIVIDE MODULO 
const ANTLR_USE_NAMESPACE(antlr)BitSet SourceParser::_tokenSet_7(_tokenSet_7_data_,4);


