/*
	Purpose:	This module contains the loader that loads parsed assembly file
				instructions into memory.
	
	Author:	Alex Stojan
*/

#ifndef _LOADER_
#define _LOADER_

#include <vector>

#include "Globals.h"

void loadData(std::vector<DataItem>, INT32*&, std::ofstream*);
void loadCode(std::vector<Instruction>, INT32*&, std::ofstream*);

#endif
