#ifndef INC_SourceParserTokenTypes_hpp_
#define INC_SourceParserTokenTypes_hpp_

/* $ANTLR 2.7.5 (20050201): "parser.g" -> "SourceParserTokenTypes.hpp"$ */

#ifndef CUSTOM_API
# define CUSTOM_API
#endif

#ifdef __cplusplus
struct CUSTOM_API SourceParserTokenTypes {
#endif
	enum {
		EOF_ = 1,
		PROGRAM = 4,
		TRUE = 5,
		FALSE = 6,
		NULLV = 7,
		RETURN = 8,
		LOOP = 9,
		IF = 10,
		ELSE = 11,
		CONTINUE = 12,
		BREAK = 13,
		WRITE = 14,
		WRITELN = 15,
		READ = 16,
		DECL = 17,
		TYPE = 18,
		ARRAY = 19,
		SCOPE = 20,
		BLOCK = 21,
		CAST = 22,
		DIM = 23,
		CONST = 24,
		CALL = 25,
		FUNCTION = 26,
		PARAMS = 27,
		INIT = 28,
		COND = 29,
		ITER = 30,
		LOOPHDR = 31,
		ARGS = 32,
		EMPTY = 33,
		INC = 34,
		DEC = 35,
		IDENT = 36,
		SEMI = 37,
		LPAREN = 38,
		RPAREN = 39,
		LCURLY = 40,
		COMMA = 41,
		RCURLY = 42,
		ASSIGN = 43,
		LBRACKET = 44,
		NUMERIC = 45,
		RBRACKET = 46,
		REF = 47,
		INCR = 48,
		DECR = 49,
		OR = 50,
		AND = 51,
		NEQ = 52,
		EQ = 53,
		TK_LT = 54,
		GT = 55,
		LE = 56,
		GE = 57,
		PLUS = 58,
		MINUS = 59,
		STAR = 60,
		DIVIDE = 61,
		MODULO = 62,
		NOT = 63,
		ADDR = 64,
		CHAR = 65,
		STRING = 66,
		WS = 67,
		DOT = 68,
		ARROW = 69,
		DIRECTIVE = 70,
		INS_START = 71,
		INS_END = 72,
		COMMENT = 73,
		COMMENT_2 = 74,
		DIGIT = 75,
		LETTER = 76,
		FORWARD = 77,
		NULL_TREE_LOOKAHEAD = 3
	};
#ifdef __cplusplus
};
#endif
#endif /*INC_SourceParserTokenTypes_hpp_*/
